#include <fstream>
#include <iostream>
#include <iterator>
#include <list>
#include <vector>

#include "stats.hpp"
tm_stats g_counter, c_counter;

#include "infinite_tape.hpp"
#include "long_int.hpp"
#include "state.hpp"
#include "turing_machine.hpp"
#include "non_halt_detection.hpp"
#include "non_halt_data_structures.hpp"
#include "machine_storage.hpp"
#include "watch.hpp"

int main()
{
	turing_machine<unsigned short> machine(5,0);

	machine.set_halt_state(4);

	machine.add_write_transition(0,0,1,1);
	machine.add_move_transition(0,1, turing_machine<unsigned short>::left, 3);
	machine.add_move_transition(1,0, turing_machine<unsigned short>::left, 0);
	machine.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine.add_move_transition(2,0, turing_machine<unsigned short>::left, 3);
	machine.add_move_transition(2,1, turing_machine<unsigned short>::right, 1);
	machine.add_move_transition(3,1, turing_machine<unsigned short>::left, 0);

	if(alternateChristmasTree(machine, 500))
		std::cout << "yes" << std::endl;

	turing_machine<unsigned short> machine2(5,0);

	machine2.set_halt_state(4);

	machine2.add_write_transition(0,0,1,1);
	machine2.add_move_transition(0,1, turing_machine<unsigned short>::left, 0);
	machine2.add_move_transition(1,0, turing_machine<unsigned short>::left, 0);
	machine2.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine2.add_write_transition(2,0,1,0);
	machine2.add_move_transition(2,1, turing_machine<unsigned short>::right, 3);
	machine2.add_move_transition(3,1, turing_machine<unsigned short>::right, 1);

	if(alternateChristmasTree(machine2, 500))
		std::cout << "yes" << std::endl;

	turing_machine<unsigned short> machine3(5,0);

	machine3.set_halt_state(4);

	machine3.add_write_transition(0,0,1,1);
	machine3.add_move_transition(0,1, turing_machine<unsigned short>::left, 0);
	machine3.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine3.add_move_transition(2,0, turing_machine<unsigned short>::right, 3);
	machine3.add_move_transition(2,1, turing_machine<unsigned short>::right, 3);
	machine3.add_write_transition(3,0,1,0);
	machine3.add_move_transition(3,1, turing_machine<unsigned short>::right, 1);

	if(alternateChristmasTree(machine3, 1000))
		std::cout << "yes" << std::endl;

	turing_machine<unsigned short> machine4(5,0);

	machine4.set_halt_state(4);

	machine4.add_write_transition(0,0,1,1);
	machine4.add_move_transition(0,1, turing_machine<unsigned short>::left, 0);
	machine4.add_move_transition(1,0, turing_machine<unsigned short>::left, 0);
	machine4.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine4.add_move_transition(2,0, turing_machine<unsigned short>::right, 3);
	machine4.add_move_transition(2,1, turing_machine<unsigned short>::right, 1);
	machine4.add_move_transition(3,0, turing_machine<unsigned short>::left, 1);
	machine4.add_write_transition(3,1,1,4);

	if(alternateChristmasTree(machine4, 1000))
		std::cout << "boo yeah" << std::endl;
	else
		std::cout << "boo no" << std::endl;

	turing_machine<unsigned short> machine5(6,0);

	machine5.set_halt_state(5);

	machine5.add_write_transition(0,0,1,0);
	machine5.add_move_transition(0,1, turing_machine<unsigned short>::right, 1);
	machine5.add_move_transition(1,0, turing_machine<unsigned short>::right, 2);
	machine5.add_move_transition(1,1, turing_machine<unsigned short>::right, 3);
	machine5.add_write_transition(2,0,1,1);
	machine5.add_write_transition(3,0,1,4);
	machine5.add_move_transition(3,1, turing_machine<unsigned short>::left, 0);
	machine5.add_move_transition(4,0, turing_machine<unsigned short>::right, 0);
	machine5.add_move_transition(4,1, turing_machine<unsigned short>::left, 4);

	if(alternateChristmasTree(machine5, 10000))
		std::cout << "boo yeah" << std::endl;
	else
		std::cout << "boo no" << std::endl;

	return 0;
}
