#include <fstream>
#include <iostream>
#include <iterator>
#include <list>
#include <vector>

#include "stats.hpp"
tm_stats g_counter, c_counter;

#include "infinite_tape.hpp"
#include "long_int.hpp"
#include "state.hpp"
#include "turing_machine.hpp"
#include "non_halt_detection.hpp"
#include "non_halt_data_structures.hpp"
#include "machine_storage.hpp"
#include "watch.hpp"

int main()
{
	turing_machine<unsigned short> machine(6,0);

	machine.set_halt_state(5);

	machine.add_write_transition(0,0,1,1);
	machine.add_write_transition(0,1,0,1);
	machine.add_move_transition(1,0, turing_machine<unsigned short>::right, 2);
	machine.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine.add_move_transition(2,0, turing_machine<unsigned short>::right, 3);
	machine.add_move_transition(2,1, turing_machine<unsigned short>::left, 2);
	machine.add_write_transition(3,0,1,4);
	machine.add_move_transition(3,1, turing_machine<unsigned short>::right, 4);
	machine.add_write_transition(4,0,0,5);
	machine.add_move_transition(4,1, turing_machine<unsigned short>::left, 0);

	if(simpleLoopCheck(machine, 50))
		std::cout << "yes" << std::endl;

	return 0;
}
